; WinBinder setup configuration for Inno Setup

[Files]
Source: Readme.txt; DestDir: {app}; Flags: ignoreversion
Source: Changelog.txt; DestDir: {app}; Flags: ignoreversion
Source: License.txt; DestDir: {app}; Flags: ignoreversion
Source: Release_notes.txt; DestDir: {app}; Flags: ignoreversion isreadme
Source: winbinder.chm; DestDir: {app}; Components: WinBinder/Samples; Flags: ignoreversion
Source: Code\*.*; DestDir: {app}\Code; Flags: recursesubdirs ignoreversion createallsubdirs; Excludes: *.a,*.bak,*.dep,*.err,*.lib,*.lnk,*.o,*.obj,*.res,*.tws,*.xrf,tp*.bat,Website\*.*,todo_items.*; Components: WinBinder/Samples
Source: Tools\textpad\*.*; DestDir: {app}\Tools\textpad; Flags: ignoreversion; Components: WinBinder/Samples
Source: Tools\html_help\*.*; DestDir: {app}\Tools\html_help; Flags: ignoreversion; Components: WinBinder/Source
Source: Tools\inno_setup\*.*; DestDir: {app}\Tools\inno_setup; Flags: ignoreversion recursesubdirs createallsubdirs; Components: WinBinder/Source
Source: Tools\winzip\*.*; DestDir: {app}\Tools\winzip; Flags: ignoreversion recursesubdirs createallsubdirs; Components: WinBinder/Source
Source: Source\*.*; DestDir: {app}\Source; Flags: recursesubdirs ignoreversion createallsubdirs; Components: WinBinder/Source
Source: PHP\PHP4\*.*i*; DestDir: {app}\PHP\PHP4; Components: PHP/PHP_4
Source: PHP\PHP5\*.*i*; DestDir: {app}\PHP\PHP5; Components: PHP/PHP_5
Source: PHP\PHP4\php-win.exe; DestDir: {app}\PHP\PHP4; Components: PHP/PHP_4
Source: PHP\PHP5\php-win.exe; DestDir: {app}\PHP\PHP5; Components: PHP/PHP_5
Source: PHP\PHP4\ext\php_winbinder.dll; DestDir: {app}\PHP\PHP4\ext; Components: PHP/PHP_4
Source: PHP\PHP5\ext\php_winbinder.dll; DestDir: {app}\PHP\PHP5\ext; Components: PHP/PHP_5
Source: PHP\PHP5\ext\php_mysql.dll; DestDir: {app}\PHP\PHP5; Components: PHP/PHP_5/AddLib5
Source: PHP\PHP4\ext\php_sqlite.dll; DestDir: {app}\PHP\PHP4; Components: PHP/PHP_4/AddLib4
Source: PHP\PHP5\ext\php_mysql.dll; DestDir: {app}\PHP\PHP5; Components: PHP/PHP_5/AddLib5
Source: C:\Arquivos de Programas\Inno Setup\Unzip\unzip.exe; DestDir: {tmp}; Components: PHP/PHP_4; AfterInstall: UnzipFiles('4')
Source: C:\Arquivos de Programas\Inno Setup\Unzip\unzip.exe; DestDir: {tmp}; Components: PHP/PHP_5; AfterInstall: UnzipFiles('5')
Source: C:\Arquivos de Programas\Inno Setup\ISX Download DLL\isxdl.dll; DestDir: {tmp}; Flags: dontcopy

[Icons]
Name: {group}\Read Me; Filename: {app}\Readme.txt
Name: {group}\Welcome to WinBinder; Filename: {app}\PHP\PHP4\php-win.exe; Parameters: """{app}\code\hello\welcome.phpw"""; Components: PHP/PHP_4; WorkingDir: {app}\code\hello; IconIndex: 0
Name: {group}\Welcome to WinBinder; Filename: {app}\PHP\PHP5\php-win.exe; Parameters: """{app}\code\hello\welcome.phpw"""; Components: PHP/PHP_5 and not PHP/PHP_4; WorkingDir: {app}\code\hello; IconIndex: 0
Name: {userdesktop}\Welcome to WinBinder; Filename: {app}\PHP\PHP4\php-win.exe; Parameters: """{app}\code\hello\welcome.phpw"""; Components: PHP/PHP_4; WorkingDir: {app}\code\hello; IconIndex: 0
Name: {userdesktop}\Welcome to WinBinder; Filename: {app}\PHP\PHP5\php-win.exe; Parameters: """{app}\code\hello\welcome.phpw"""; Components: PHP/PHP_5 and not PHP/PHP_4; WorkingDir: {app}\code\hello; IconIndex: 0
Name: {group}\WinBinder Manual; Filename: {app}\winbinder.chm
Name: {group}\Release notes; Filename: {app}\Release_notes.txt
Name: {group}\Changelog; Filename: {app}\Changelog.txt
Name: {group}\License; Filename: {app}\License.txt
Name: {group}\Uninstall\Uninstall WinBinder; Filename: {uninstallexe}

[Setup]
OutputDir=Archive
OutputBaseFilename=winbinder_setup
SolidCompression=true
VersionInfoCompany=Hypervisual
VersionInfoDescription=WinBinder
AppCopyright=Copyright  2004 Hypervisual - see LICENSE.TXT for details
AppName=WinBinder
LicenseFile=C:\@desenv\WinBinder\License.txt
RestartIfNeededByRun=false
DefaultGroupName=WinBinder
ShowLanguageDialog=no
AppVerName=WinBinder version 0.40.152
DefaultDirName={sd}\WinBinder
MinVersion=4.1.1998,5.0.2195
UsePreviousAppDir=true
Compression=lzma
UninstallDisplayName=
AppComments=Uninstall this application
AppID={{EF0FB390-6815-4BC3-A070-C7525D5625C4}
UninstallFilesDir={app}\uninstall
VersionInfoVersion=0.40.152
UseSetupLdr=true
AppMutex=winbinder-app
EnableDirDoesntExistWarning=true
FlatComponentsList=false
DisableStartupPrompt=false
AlwaysShowComponentsList=true
DirExistsWarning=no
ChangesAssociations=true
MergeDuplicateFiles=false
SourceDir=..\..\
InternalCompressLevel=normal

[Run]
Filename: {app}\PHP\PHP4\php-win.exe; Parameters: """{app}\code\hello\welcome.phpw"""; Flags: nowait postinstall; Description: Run Welcome application; WorkingDir: {app}\code\hello; Components: PHP/PHP_4
Filename: {app}\PHP\PHP5\php-win.exe; Components: PHP/PHP_5 and not PHP/PHP_4; Parameters: """{app}\code\hello\welcome.phpw"""; Flags: nowait postinstall; Description: Run Welcome application; WorkingDir: {app}\code\hello

[Components]
Name: WinBinder; Description: WinBinder; Flags: fixed; Types: Default Update_only Custom_install
Name: WinBinder/Samples; Description: Help and examples; Types: Default Update_only; Flags: dontinheritcheck
Name: WinBinder/Source; Description: C source code and tools; Flags: dontinheritcheck; Types: Update_only
Name: PHP; Description: PHP; Flags: fixed; Types: Custom_install
Name: PHP/PHP_4; Description: PHP 4 (download); ExtraDiskSpaceRequired: 1400000; Flags: dontinheritcheck; Types: Default Update_PHP
Name: PHP/PHP_4/AddLib4; Description: SQLite; Types: Default Update_PHP; Flags: dontinheritcheck
Name: PHP/PHP_5; Description: PHP 5 (download); ExtraDiskSpaceRequired: 3600000; Flags: dontinheritcheck; Types: Update_PHP
Name: PHP/PHP_5/AddLib5; Description: MySQL; Flags: dontinheritcheck; Types: Update_PHP

[Types]
Name: Default; Description: Default installation
Name: Update_only; Description: Update an existing WinBinder installation
Name: Update_PHP; Description: Update PHP version only
Name: Custom_install; Description: Custom; Flags: iscustom

[Registry]
Root: HKCR; SubKey: .phpw; ValueType: string; ValueData: WinBinder script; Flags: uninsdeletekey
Root: HKCR; SubKey: WinBinder script file; ValueType: string; ValueData: WinBinder script; Flags: uninsdeletekey
Root: HKCR; SubKey: WinBinder script\Shell\Open\Command; ValueType: string; ValueData: """{app}\php\php4\php-win.exe"" ""%1"""; Flags: uninsdeletevalue; Components: PHP/PHP_4
Root: HKCR; Subkey: WinBinder script\DefaultIcon; ValueType: string; ValueData: {app}\php\php4\php-win.exe,0; Flags: uninsdeletevalue; Components: PHP/PHP_4
Root: HKCR; SubKey: WinBinder script\Shell\Open\Command; ValueType: string; ValueData: """{app}\php\php5\php-win.exe"" ""%1"""; Flags: uninsdeletevalue; Components: PHP/PHP_5
Root: HKCR; Subkey: WinBinder script\DefaultIcon; ValueType: string; ValueData: {app}\php\php5\php-win.exe,0; Flags: uninsdeletevalue; Components: PHP/PHP_5
Root: HKCU; Subkey: Software\WinBinder; ValueType: string; ValueName: InstallDir; ValueData: {app}; Flags: uninsdeletekeyifempty uninsdeletevalue

[LangOptions]
DialogFontName=Microsoft Sans Serif

[Tasks]

[INI]
;Filename: {app}\PHP\PHP4\php.ini; Section: PHP; Key: extension; String: php_sqlite.dll; Components: PHP/PHP_4/AddLib4
;Filename: {app}\PHP\PHP5\php.ini; Section: PHP; Key: extension; String: php_mysql.dll; Components: PHP/PHP_5/AddLib5

[Code]
// Isxdl functions (from isxdl.iss)

function isxdl_Download(hWnd: Integer; URL, Filename: PChar): Integer;
external 'isxdl_Download@files:isxdl.dll stdcall';

procedure isxdl_AddFile(URL, Filename: PChar);
external 'isxdl_AddFile@files:isxdl.dll stdcall';

procedure isxdl_AddFileSize(URL, Filename: PChar; Size: Cardinal);
external 'isxdl_AddFileSize@files:isxdl.dll stdcall';

function isxdl_DownloadFiles(hWnd: Integer): Integer;
external 'isxdl_DownloadFiles@files:isxdl.dll stdcall';

procedure isxdl_ClearFiles;
external 'isxdl_ClearFiles@files:isxdl.dll stdcall';

function isxdl_IsConnected: Integer;
external 'isxdl_IsConnected@files:isxdl.dll stdcall';

function isxdl_SetOption(Option, Value: PChar): Integer;
external 'isxdl_SetOption@files:isxdl.dll stdcall';

function isxdl_GetFileName(URL: PChar): PChar;
external 'isxdl_GetFileName@files:isxdl.dll stdcall';

const
	server = 'http://osdn.dl.sourceforge.net/sourceforge/winbinder/';
	php4file = 'php4_minimal.zip';
	php5file = 'php5_minimal.zip';
	php4exts = 'php4_libs.zip';
	php5exts = 'php4_libs.zip';
var
  nCode: Integer;
  unzippgm: String;
  targetdir: String;
  cmd: String;

// Unzip files

procedure Go(source: String);
  begin
    source := ExpandConstant('{tmp}\' + source);
	if not FileExists(unzippgm) then MsgBox('Could not find file ' + unzippgm, mbError, MB_OK)
	else if not FileExists(source) then MsgBox('Could not find file ' + source, mbError, MB_OK)
	else begin
		cmd := '-o -qq "' + source + '" -d "' + targetdir + '"';
		if Exec(unzippgm, cmd, '', SW_HIDE, ewWaitUntilIdle, nCode) = false then begin
			MsgBox('Could not run', mbError, MB_OK);
		end;
	end;
end;

procedure UnzipFiles(Ver: String);
var
  sComp: String;
begin
  sComp := WizardSelectedComponents(false);
  unzippgm := ExpandConstant('{tmp}\unzip.exe');
  targetdir := ExpandConstant('{app}\php\php' + Ver);
  if Pos('php_4', sComp) > 0 then Go(php4file);
  if Pos('php_5', sComp) > 0 then Go(php5file);
  if Pos('addlib4', sComp) > 0 then Go(php4exts);
  if Pos('addlib5', sComp) > 0 then Go(php5exts);
end;

// Download files

function NextButtonClick(CurPage: Integer): Boolean;
var
  hWnd: Integer;
  sComp: String;
  sFileName: String;
begin
  Result := true;

  if CurPage = wpReady then begin

    hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));
    sComp := WizardSelectedComponents(false);
    isxdl_ClearFiles;

    if Pos('php_4', sComp) > 0 then begin
      sFileName := ExpandConstant('{tmp}\' + php4file);
      isxdl_AddFile(server + php4file, sFileName);
    end;

    if Pos('php_5', sComp) > 0 then begin
      sFileName := ExpandConstant('{tmp}\' + php5file);
      isxdl_AddFile(server + php5file, sFileName);
    end;

    if Pos('addlib4', sComp) > 0 then begin
      sFileName := ExpandConstant('{tmp}\' + php4exts);
      isxdl_AddFile(server + php4exts, sFileName);
    end;

    if Pos('addlib5', sComp) > 0 then begin
      sFileName := ExpandConstant('{tmp}\' + php5exts);
      isxdl_AddFile(server + php5exts, sFileName);
    end;

    if isxdl_DownloadFiles(hWnd) = 0 then begin
        MsgBox('Download failed.', mbError, MB_OK);
        Result := false;
    end;
  end;
end;

function InitializeSetup: Boolean;
begin
  isxdl_SetOption('title','Setup - WinBinder');
  isxdl_SetOption('label','Download PHP runtime files');
  isxdl_SetOption('description','Please wait until the download is completed.');
  isxdl_SetOption('resume','false');
  Result := true;
end;
